# Generated by Django 3.2.2 on 2021-11-27 21:12

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django_extensions.db.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Answer',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('source_code', models.TextField()),
                ('is_corrected', models.BooleanField(default=False)),
                ('is_valid', models.BooleanField(default=False)),
                ('is_shared', models.BooleanField(default=False)),
                ('correction_message', models.TextField(blank=True, default='')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('corrected_at', models.DateTimeField(blank=True, null=True)),
                ('is_unhelpfull', models.BooleanField(blank=True, default=False)),
                ('votes', models.IntegerField(blank=True, default=0)),
                ('is_safe', models.BooleanField(blank=True, default=False)),
            ],
        ),
        migrations.CreateModel(
            name='Category',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=255)),
                ('title_en', models.CharField(max_length=255, null=True)),
                ('title_fr', models.CharField(max_length=255, null=True)),
                ('slug', django_extensions.db.fields.AutoSlugField(blank=True, editable=False, populate_from=['title'])),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('position', models.FloatField(default=0)),
            ],
            options={
                'verbose_name_plural': 'Categories',
            },
        ),
        migrations.CreateModel(
            name='Membership',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('role', models.CharField(choices=[('PE', 'Pending'), ('MM', 'Member'), ('ST', 'Staff')], default='MM', max_length=2)),
            ],
        ),
        migrations.CreateModel(
            name='Page',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slug', models.CharField(max_length=64)),
                ('title', models.CharField(max_length=512)),
                ('title_en', models.CharField(max_length=512, null=True)),
                ('title_fr', models.CharField(max_length=512, null=True)),
                ('body', models.TextField(blank=True, default='')),
                ('body_en', models.TextField(blank=True, default='', null=True)),
                ('body_fr', models.TextField(blank=True, default='', null=True)),
                ('position', models.FloatField(blank=True, default=0)),
                ('in_menu', models.BooleanField(blank=True, default=False)),
            ],
        ),
        migrations.CreateModel(
            name='Vote',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.IntegerField()),
                ('answer', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hkis.answer')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='UserInfo',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('points', models.FloatField(default=0)),
                ('rank', models.PositiveIntegerField(blank=True, null=True)),
                ('public_profile', models.BooleanField(default=True)),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='hkis', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Team',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=42, unique=True)),
                ('slug', django_extensions.db.fields.AutoSlugField(blank=True, editable=False, populate_from=['name'], unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('is_public', models.BooleanField(default=True)),
                ('points', models.FloatField(default=0)),
                ('members', models.ManyToManyField(related_name='teams', through='hkis.Membership', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Snippet',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('source_code', models.TextField()),
                ('output', models.TextField(blank=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('executed_at', models.DateTimeField(blank=True, null=True)),
                ('user', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.AddField(
            model_name='membership',
            name='team',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hkis.team'),
        ),
        migrations.AddField(
            model_name='membership',
            name='user',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL),
        ),
        migrations.CreateModel(
            name='Exercise',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=255)),
                ('title_en', models.CharField(max_length=255, null=True)),
                ('title_fr', models.CharField(max_length=255, null=True)),
                ('slug', django_extensions.db.fields.AutoSlugField(blank=True, editable=False, populate_from=['title'])),
                ('pre_check', models.TextField(blank=True, null=True)),
                ('check', models.TextField(blank=True, default='')),
                ('is_published', models.BooleanField(default=False)),
                ('wording', models.TextField(blank=True, default='')),
                ('wording_en', models.TextField(blank=True, default='', null=True)),
                ('wording_fr', models.TextField(blank=True, default='', null=True)),
                ('initial_solution', models.TextField(blank=True, default='')),
                ('position', models.FloatField(default=0)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('points', models.IntegerField(default=1)),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('category', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='hkis.category')),
                ('page', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, related_name='exercises', to='hkis.page')),
            ],
            options={
                'ordering': ('category__position', 'category', 'position'),
            },
        ),
        migrations.AddField(
            model_name='answer',
            name='exercise',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='answers', to='hkis.exercise'),
        ),
        migrations.AddField(
            model_name='answer',
            name='user',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AlterUniqueTogether(
            name='membership',
            unique_together={('user', 'team')},
        ),
        migrations.AddIndex(
            model_name='answer',
            index=models.Index(fields=['exercise', '-votes'], name='hkis_answer_exercis_f0b56e_idx'),
        ),
        migrations.AddIndex(
            model_name='answer',
            index=models.Index(fields=['is_valid', 'is_safe'], name='hkis_answer_is_vali_62f948_idx'),
        ),
    ]
